﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Microsoft.Win32;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Infragistics.Documents.Excel;
using System.IO;
using System.Diagnostics;
using Infragistics.Windows.Reporting;

namespace XamDataGridTesting
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void btnExcel_Click(object sender, RoutedEventArgs e)
        {
            Export(this.grid, true);
        }

        public static bool Export(DataPresenterBase xamDataPresenter, bool bShowOnceComplete)
        {
            bool bRet = false;

            string sFile = "";

            SaveFileDialog dialog;

            // Export to xlsx excel file format
            dialog = new SaveFileDialog { Filter = "Excel files|*.xlsx", DefaultExt = "xlsx" };

            if (dialog.ShowDialog() == true)
            {
                sFile = dialog.FileName;
            }

            if (sFile != "")
            {
                // create the exporter and set the options
                DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
                ExportOptions options = new ExportOptions();

                options.FileLimitBehaviour = FileLimitBehaviour.ThrowException;
                exporter.Export(xamDataPresenter, sFile, WorkbookFormat.Excel2007);
                bRet = true;


                // show the new file?
                if ((bShowOnceComplete == true) && (bRet == true))
                {
                    Process process = new Process();
                    process.StartInfo.FileName = sFile;
                    process.Start();
                }
            }

            return bRet;
        }

        private void btnPrint_Click(object sender, RoutedEventArgs e)
        {
            Report report = new Report();

            report.ReportSettings.PageOrientation = PageOrientation.Landscape;

            EmbeddedVisualReportSection section = new EmbeddedVisualReportSection(grid);
            report.Sections.Add(section);

            printPreview.GeneratePreview(report, false, true);
        }

    }
}
